
public class TMatrix {
	
	public double[][] MultMatrixRight(double[][] a, double[][] m, int p, int q, int size)
    {
        int i, k;
        double[][] al = new double[size][2];
        for (i = 0; i < size; i++)
        {
            al[i][0] = 0.0;
            al[i][1] = 0.0;
            for (k = 0; k < size; k++)
            {
                al[i][0] = al[i][0] + (a[i][k] * m[k][p]);
                al[i][1] = al[i][1] + (a[i][k] * m[k][q]);
            }
        }
        for (i = 0; i < size; i++)
        {
            a[i][p] = al[i][0];
            a[i][q] = al[i][1];
        }
        return a;
    }


    public double[][] MultTranspMatrixLeft(double[][] a, double[][] m, int p, int q, int size)
    {
        int j, k;
        double[][] al = new double[2][size];
        for (j = 0; j < size; j++)
        {
            al[0][j] = 0.0;
            al[1][j] = 0.0;
            for (k = 0; k < size; k++)
            {
                al[0][j] = al[0][j] + (m[k][p] * a[k][j]);
                al[1][j] = al[1][j] + (m[k][q] * a[k][j]);
            }
        }
        for (j = 0; j < size; j++)
        {
            a[p][j] = al[0][j];
            a[q][j] = al[1][j];
        }
        return a;
    }

    public double[][] MultNormal(double[][] a, double[][] b, int xA, int yA, int xB, int yB)
    {
        double[][] c = new double[yA][xA];
        for(int x = 0; x < xB; x++)
        {
            for (int y = 0; y < yA; y++)
            {
                c[y][x] = 0;
                for (int k = 0; k < xA; k++)
                    c[y][x] = c[y][x] + a[y][k] * b[k][x];
            }
        }
        return c;
    }


    public double[][] MultTrans(double[][] a, double[][] b, int xA, int yA, int xB, int yB)
    {
        double[][] c = new double[yA][xB];
        for (int x = 0; x < xA; x++)
        {
            for (int y = 0; y < yA; y++)
            {
                c[y][x] = 0;
                for (int k = 0; k < xA; k++)
                    c[y][x] = c[y][x] + a[y][k] * b[x][k];
            }
        }
        return c;
    }

}
