import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JTable;
import java.awt.BorderLayout;
import javax.swing.border.BevelBorder;
import java.awt.Font;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Toolkit;

public class mainFrame {

	private JFrame frmSingularValueDecomposition;
	private JTable tbMAtrix;
	private JTable tbEigenvalues;
	private JTable tbUvalues;
	private JTable tbDvalues;
	
	int n = 6;      // y order
    int m = 6;      // x order
	public double[][] a = new double[n][m];   // starting matrix
    public double[][] ori = new double[n][m]; // origing matrix (copy of A)
    public double[][] r = new double[n][n];   // rotation matrix for Jacoby
    public double[][] v = new double[m][n];
    public double[][] u = new double[n][n];
    public double[] d = new double[m];
    public int rank = 0;
	
	String[][] strMatrix	= {
				
				{"22", "52", "1", "93", "70", "33"},
				{"5", "83", "38", "85", "91", "63"},
				{"68", "3", "7", "53", "76", "76"},
				{"68", "5", "42", "9", "26", "99"},
				{"93", "53", "69", "65", "5", "37"},
				{"38", "67", "59", "42", "74", "25"},
	};
	
	String[][] strEigenVect	= {
			
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
	};
	
	String[][] strUVect	= {
			
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
			{"", "", "", "", "", ""},
	};

	String[][] strDVect	= {
		
		{"", "", "", "", "", ""},
		{"", "", "", "", "", ""},
		{"", "", "", "", "", ""},
		{"", "", "", "", "", ""},
		{"", "", "", "", "", ""},
		{"", "", "", "", "", ""},
	};
		
	String[] title = {"x1", "x2", "x3", "x4", "x5", "x6"};

	TMatrix matrix = new TMatrix();
	tDataGrid matrixData;
	tDataGrid eigenVectors;
	tDataGrid uVectors;
	tDataGrid dVectors;
	
	public void CalcRMatrix(double[][] a, int p, int q, int size)
    {
        int i, j;
        double phi;
        double t;
        phi = (a[q][q] - a[p][p]) / 2 / a[q][p];
        if (phi != 0)
        {
            if (phi > 0)
                t = 1/(phi + Math.sqrt(phi * phi + 1.0));
            else
                t = 1/(phi - Math.sqrt(phi * phi + 1.0));
        }
        else
            t = 1.0;
        for (i = 0; i < size; i++)
        {
            for (j = 0; j < size; j++)
            {
                r[i][j] = 0.0;
            }
            r[i][i] = 1.0;
        }
        r[p][p] = 1 / Math.sqrt(t * t + 1.0);
        r[p][q] = t * r[p][p];
        r[q][q] = r[p][p];
        r[q][p] = -r[p][q];
    }

	
	public void RunJacobi(int maxOrder)
    {
        int i, k, count = 0;
        double delta = 10;
        while ((delta > 1.0E-40) && (count < 50))
        {
            delta = 0;
            count++;
            for (i = 0; i < maxOrder; i++)
            {
                for (k = i + 1; k < maxOrder; k++)
                {
                    if (a[k][i] != 0.0)
                    {
                        CalcRMatrix(a, i, k, maxOrder);
                        a = matrix.MultTranspMatrixLeft(a, r, i, k, maxOrder);
                        a = matrix.MultMatrixRight(a, r, i, k, maxOrder);
                        v = matrix.MultMatrixRight(v, r, i, k, maxOrder);
                    }
                }
                if(i< maxOrder-1)
                    delta = delta + Math.abs(a[i+1][i]);
            }
        }    
    }
	
	void FillCols(int empties)
    {
        int i;
        int index;
        TGauss gauss = new TGauss(n, u);
        for (index = 0; index < empties; index++)
        {
            gauss.Eliminate(empties);
            gauss.Solve(empties - index);
            for (i = 0; i < n; i++)
            {
                u[i][n - empties + index] = gauss.x[i];
            }
        }
    }
	
	void calculate()
	{
		String str;
		int i, j, k;
		int index;
		double tempVal;
		double[][] buf = new double[n][m];

         for (i = 0; i < m; i++)
         {
             for (k = 0; k < n; k++)
             {
            	str = matrixData.getValueAt(i, k).toString();
 				a[i][k] = Float.parseFloat(str);
                ori[i][k] = a[i][k];

               // d values lschen
             }
         }
         for (i = 0; i < m; i++) // initialise V 
         {
             for (k = 0; k < m; k++)
             {
                 v[k][i] = 0.0;
             }
             v[i][i] = 1.0;
         }

         // calculate  A^T * A 
         for (i = 0; i < m; i++)
         {
             for (j = 0; j < m; j++)
             {
                 buf[j][i] = 0.0;
                 for (k = 0; k < n; k++)
                 {
                     buf[j][i] = buf[j][i] + a[k][j] * a[k][i];
                 }
             }
         }
         for (i = 0; i < m; i++)
         {
             for (j = 0; j < m; j++)
             {
                 a[j][i] = buf[j][i];
             }
         }

         // calculate the eigenvalues
         RunJacobi(m);

         // calculate d
         for (i = 0; i < m; i++)
         {
             if (a[i][i] > 0)
                 d[i] = Math.sqrt(a[i][i]);
             else
                 d[i] = 0;
         }


         // order values
         for (i = 0; i < m - 1; i++)
         {
             index = i;
             for (j = i + 1; j < m; j++)
             {

                 if (d[j] > d[index])
                     index = j;
             }

             tempVal = d[i];
             d[i] = d[index];
             d[index] = tempVal;
             for (j = 0; j < m; j++)
             {
                 tempVal = v[j][i];
                 v[j][i] = v[j][index];
                 v[j][index] = tempVal;
             }
         }

         rank = 1;
         for (i = 0; i < m; i++)
         {
             if (Math.abs(d[i]) > 1E-5)
                 rank = i + 1;
         }

         // calculate u
         for (i = 0; i < rank; i++)
         {
             for (j = 0; j < n; j++)
             {
                 u[j][i] = 0;
                 for (k = 0; k < m; k++)
                 {
                     u[j][i] = u[j][i] + ori[j][k] * v[k][i];
                 }
                 if (d[i] != 0)
                     u[j][i] = u[j][i] / d[i];
             }
         }

         if ((rank > 1) && (rank < n))
             FillCols(n - rank);  // fill empty columns of U

         for (i = 0; i < m; i++)  // display results
         {
             for (k = 0; k < n; k++)
             {                
                 matrixData.setValueAt(Double.toString(Math.round(a[i][k]*1000.0)/1000.0), i, k);

                 if (k < m)
                 {
                     eigenVectors.setValueAt(Double.toString(Math.round(v[i][k]*1000.0)/1000.0), i, k);
                 }

             }
             dVectors.setValueAt(Double.toString(Math.round(d[i]*1000.0)/1000.0), i, i);
         }

         for (i = 0; i < n; i++)
         {
             for (k = 0; k < n; k++)
             {                
                 uVectors.setValueAt(Double.toString(Math.round(u[i][k]*1000.0)/1000.0), i, k);
             }
         }
	}
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					mainFrame window = new mainFrame();
					window.frmSingularValueDecomposition.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public mainFrame() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmSingularValueDecomposition = new JFrame();
		frmSingularValueDecomposition.setTitle("Singular value decomposition");
		frmSingularValueDecomposition.setIconImage(Toolkit.getDefaultToolkit().getImage(mainFrame.class.getResource("/Ressource/Icon.png")));
		frmSingularValueDecomposition.setBounds(100, 100, 652, 545);
		frmSingularValueDecomposition.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmSingularValueDecomposition.getContentPane().setLayout(null);
		
		matrixData = new tDataGrid(strMatrix, title, n, n);
		tbMAtrix = new JTable(matrixData);
		tbMAtrix.setSize(549, 200);
		tbMAtrix.setLocation(30, 11);
		tbMAtrix.setRowHeight(25);
		tbMAtrix.setFont(new Font("Tahoma", Font.PLAIN, 14));
		tbMAtrix.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		frmSingularValueDecomposition.getContentPane().add(tbMAtrix, BorderLayout.CENTER);
		
		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);
		tabbedPane.setBounds(30, 234, 563, 262);
		frmSingularValueDecomposition.getContentPane().add(tabbedPane);
			
		JPanel pnEigenvalues = new JPanel();
		pnEigenvalues.setLayout(null);
		tabbedPane.addTab("Eigenvalues", null, pnEigenvalues, null);
		
		eigenVectors = new tDataGrid(strEigenVect, title, n, n);
		tbEigenvalues = new JTable(eigenVectors);
		tbEigenvalues.setSize(538, 213);
		tbEigenvalues.setLocation(10, 10);
		tbEigenvalues.setRowHeight(25);
		tbEigenvalues.setFont(new Font("Tahoma", Font.PLAIN, 14));
		tbEigenvalues.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		pnEigenvalues.add(tbEigenvalues);
			
		JPanel pnUValues = new JPanel();
		pnUValues.setLayout(null);
		tabbedPane.addTab("U vectors", null, pnUValues, null);
		
		uVectors = new tDataGrid(strUVect, title, n, n);
		tbUvalues = new JTable(uVectors);
		tbUvalues.setSize(538, 213);
		tbUvalues.setLocation(10, 10);
		tbUvalues.setRowHeight(25);
		tbUvalues.setFont(new Font("Tahoma", Font.PLAIN, 14));
		tbUvalues.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		pnUValues.add(tbUvalues);
		
		JPanel pnDValues = new JPanel();
		pnDValues.setLayout(null);
		tabbedPane.addTab("D values", null, pnDValues, null);
		
		dVectors= new tDataGrid(strDVect, title, n, n);
		tbDvalues = new JTable(dVectors);
		tbDvalues.setSize(538, 213);
		tbDvalues.setLocation(10, 10);
		tbDvalues.setRowHeight(25);
		tbDvalues.setFont(new Font("Tahoma", Font.PLAIN, 14));
		tbDvalues.setBorder(new BevelBorder(BevelBorder.LOWERED, null, null, null, null));
		pnDValues.add(tbDvalues);
		
		JButton btnNewButton = new JButton("New button");
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				calculate();
			}
		});
		btnNewButton.setBounds(490, 222, 89, 23);
		frmSingularValueDecomposition.getContentPane().add(btnNewButton);
	}
}
